package org.example.data.repository

import org.example.data.model.ShoesDTO
import org.example.data.shoes
import org.example.domain.request.AddShoesRequest

class ShoesRepositoryImpl: ShoesRepository {
    private val shoesSource: MutableList<ShoesDTO> = shoes.toMutableList()
    override fun add(addShoesRequest: AddShoesRequest): ShoesDTO{
        val newShoes = ShoesDTO(
            id = shoesSource.size+1,
            name = addShoesRequest.name,
            brand = addShoesRequest.brand,
            size = addShoesRequest.size,
            color = addShoesRequest.color,
            price = addShoesRequest.price
        )
        shoesSource.add(newShoes)
        return newShoes
    }

    override fun getShoesById(id: Int): ShoesDTO {
        val need = shoesSource.first{it.id==id}
        return need
    }

    override fun getAllShoes(): List<ShoesDTO> {
        return shoesSource
    }

    override fun update(id:  Int,updateShoes:ShoesDTO): Boolean {
        val updatable = shoesSource.first { it.id == id }
        updatable.name=updateShoes.name
        updatable.brand=updateShoes.brand
        updatable.size=updateShoes.size
        updatable.color=updateShoes.color
        updatable.price=updateShoes.price
        return(true)
    }

    override fun delete(id: Int): Boolean {
        shoesSource.removeIf {it.id==id}
        return true
    }
}